#include<reg52.h>
#define uint unsigned int
#define uchar unsigned char
uchar aa,shi1,shi0,fen1,fen0,miao1,miao0;
uint temp;
sbit dula=P2^6;
sbit wela=P2^7;
uchar code table[]={
0x3f,0x06,0x5b,0x4f,
0x66,0x6d,0x7d,0x07,
0x7f,0x6f,0x77,0x7c,
0x39,0x5e,0x79,0x71};
void display(uchar shi1,shi0,fen1,fen0,miao1,miao0);
void delay(uint z);
void init();
void main()
{	
	init();//³õÊ¼»¯×Ó³ÌÐò
	while(1)
	{
		if(aa==20)
		  {
			aa=0;
			temp++;
			if(temp==86400)
			   {
					temp=0;
			   }
			shi1=temp/3600/10;
			shi0=temp/3600-(shi1*10);
			fen1=temp%3600/60/10;
			fen0=temp%3600/60-(fen1*10);
			miao1=temp%3600%60/10;
			miao0=temp%3600%60-(miao1*10);
		  }
		display(shi1,shi0,fen1,fen0,miao1,miao0);
	}
}

void delay(uint z)
{
	uint x,y;
	for(x=z;x>0;x--)
		for(y=110;y>0;y--);
}

void display(uchar shi1,shi0,fen1,fen0,miao1,miao0)
{
      	dula=1;
		P0=table[shi1];
		dula=0;

		P0=0xff;
		wela=1;

		P0=0xfe;
		wela=0;
		delay(1);

		dula=1;
		P0=table[shi0];
		dula=0;

		P0=0xff;
		
		wela=1;
		P0=0xfd;
		wela=0;
		delay(1);

		dula=1;
		P0=0x40;//"-"
		dula=0;

		P0=0xff;
		
		wela=1;
		P0=0xfb;
		wela=0;
		delay(1);
		
		dula=1;
		P0=table[fen1];
		dula=0;

		P0=0xff;

		wela=1;
		P0=0xf7;
		wela=0;
		delay(1);

		
		dula=1;
		P0=table[fen0];
		dula=0;
		P0=0xff;
		wela=1;
		P0=0xef;
		wela=0;
		delay(1);

		dula=1;
		P0=0x40;//"-"
		dula=0;

		P0=0xff;
		
		wela=1;
		P0=0xdf;
		wela=0;
		delay(1);
				
		dula=1;
		P0=table[miao1];
		dula=0;

		P0=0xff;

		wela=1;
		P0=0xbf;
		wela=0;
		delay(1);

		
		dula=1;
		P0=table[miao0];
		dula=0;

		P0=0xff;

		wela=1;
		P0=0x7f;
		wela=0;
		delay(1);
}

void init()
{	
	wela=0;
	dula=0;
	temp=41760;
	TMOD=0x01;
	TH0=(65536-46080)/256;
	TL0=(65536-46080)%256;
	EA=1;
	ET0=1;
	TCON=0x10;
	 //TR0=1;
}

void timer0() interrupt 1
{
	TH0=(65536-46080)/256;
	TL0=(65536-46080)%256;
	aa++;	
}